package com.adventurer_engine.client.model.rc;

package .tmp;

import atu;
import bfq;
import com.adventurer_engine.client.model.rc.IRCsRenderObject;
import com.adventurer_engine.client.model.rc.RCsAnimationManager;
import com.adventurer_engine.client.model.rc.RCsModelBone;
import com.adventurer_engine.client.model.rc.RCsModelBox;
import com.adventurer_engine.util.blockbench.BBModelElement;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import org.lwjgl.opengl.GL11;

public class RCsModelElement implements IRCsRenderObject {
  public String name;
  
  public RCsModelBox box;
  
  public float rotateX;
  
  public float rotateY;
  
  public float rotateZ;
  
  public float originX;
  
  public float originY;
  
  public float originZ;
  
  private boolean compiled = false;
  
  private int displayList;
  
  public RCsModelElement(RCsModelBone bone, BBModelElement bb) {
    this.rotateX = (float)bb.rotation[0];
    this.rotateY = (float)bb.rotation[1];
    this.rotateZ = (float)bb.rotation[2];
    this.originX = (float)bb.origin[0];
    this.originY = (float)bb.origin[1];
    this.originZ = (float)bb.origin[2];
    this.name = bb.name;
    this.box = new RCsModelBox(bone, bb);
  }
  
  @SideOnly(Side.CLIENT)
  public void render(float magic, RCsAnimationManager animation, float partialTicks) {
    if (!this.compiled)
      compileDisplayList(magic); 
    if (this.rotateX == 0.0F && this.rotateY == 0.0F && this.rotateZ == 0.0F) {
      GL11.glCallList(this.displayList);
    } else {
      GL11.glPushMatrix();
      GL11.glTranslatef(this.originX * magic, this.originY * magic, this.originZ * magic);
      if (this.rotateX != 0.0F)
        GL11.glRotatef(this.rotateX, 1.0F, 0.0F, 0.0F); 
      if (this.rotateY != 0.0F)
        GL11.glRotatef(this.rotateY, 0.0F, 1.0F, 0.0F); 
      if (this.rotateZ != 0.0F)
        GL11.glRotatef(this.rotateZ, 0.0F, 0.0F, 1.0F); 
      GL11.glTranslatef(-this.originX * magic, -this.originY * magic, -this.originZ * magic);
      GL11.glCallList(this.displayList);
      GL11.glPopMatrix();
    } 
  }
  
  @SideOnly(Side.CLIENT)
  public void compileDisplayList(float magic) {
    this.displayList = atu.a(1);
    GL11.glNewList(this.displayList, 4864);
    bfq tessellator = bfq.a;
    this.box.render(tessellator, magic);
    GL11.glEndList();
    this.compiled = true;
  }
}
